CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  lubksb.f   - Obtained from "Numerical Recipes"
C
C  Solves the set of N linear equations Ax=b. A is the input from
C  the ludcmp.f subroutine (not the A matrix). INDX is input as 
C  the permutation vector returned by ludcmp.f. B is the input as
C  the right hand side and after calculations are done it is 
C  returned as the x from Ax=b.
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

       subroutine lubksb( A,N,NP,INDX,B )

       implicit none
       integer NP
       integer INDX(NP),N,i,j,ii,ll
       real*8 A(NP,NP),sum,B(NP)

       ii = 0

       do i=1,N
         ll = INDX(i)
         sum = B(ll)
         B(ll) = B(i)

         if ( ii .ne. 0 ) then
           do j=ii,i-1
             sum = sum - A(i,j)*B(j)
           enddo
         else if ( sum .ne. 0.0 ) then
           ii = i
         endif

         B(i) = sum
       enddo

       do i=N,1,-1
         sum = B(i)

         if ( i .lt. N ) then
           do j=i+1,N
             sum = sum - A(i,j)*B(j) 
           enddo
         endif

         B(i) = sum/A(i,i)
       enddo

       return
       end
